<template>
  <Container class="w-full">
    <SectionHeader icon="mdi-file-cog-outline">
      Общая информация
    </SectionHeader>

    <v-card
      v-tooltip:top="{ text: 'Нажмите, чтобы изменить', openOnClick: true }"
      link
      variant="text"
      class="bg-gray-100 mt-4"
    >
      <template #prepend>
        <TextAvatar :value="guest.name" />
      </template>

      <template #title>
        <span class="select-none">
          {{ guest.name }}
        </span>
      </template>

      <template #subtitle>
        <span class="select-none">
          Создан {{ dt.display(guest.createdAt) }}
        </span>
      </template>

      <template #append>
        <v-icon icon="mdi-pencil" />
      </template>

      <v-menu
        v-model="isShown"
        location="bottom start"
        transition="scale-transition"
        activator="parent"
        :close-on-content-click="false"
      >
        <Container
          class="my-4 p-4 drop-shadow-md shadow-none"
          reset-paddings
        >
          <div class="mb-2 font-light text-lg text-gray-500 uppercase">
            Изменение гостя
          </div>

          <v-text-field
            v-model="updatedName"
            :rules="[validateName]"
            placeholder="Имя"
            class="min-w-[16rem]"
            :maxlength="MAX_GUEST_NAME_LENGTH"
          />

          <section class="pt-4">
            <v-btn
              rounded
              variant="tonal"
              class="font-bold mr-4"
              @click="isShown = false"
            >
              Отмена
            </v-btn>

            <v-btn
              rounded
              class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
              :class="{ 'opacity-50': !isDataFilled }"
              :readonly="!isDataFilled"
              @click="onEditClick"
            >
              Изменить
            </v-btn>
          </section>
        </Container>
      </v-menu>
    </v-card>
  </Container>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

import { useDateTime } from '@/composables';
import { createStringValidator } from '@/validators';
import { MIN_GUEST_NAME_LENGTH, MAX_GUEST_NAME_LENGTH } from '@/declarations';

import TextAvatar from '@/components/content/TextAvatar.vue';
import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';

const props = defineProps<{ guest: IGuest }>();
const emit = defineEmits(['update:common']);

const dt = useDateTime();

const validateName = createStringValidator({
  required: true,
  length: { min: MIN_GUEST_NAME_LENGTH, max: MAX_GUEST_NAME_LENGTH },
});

const isShown = ref(false);
const updatedName = ref(props.guest.name);

const isDataFilled = computed(() => {
  return validateName(updatedName.value) === true;
});

const onEditClick = () => {
  emit('update:common', { name: updatedName.value.trim() });
  isShown.value = false;
};

watch(isShown, () => {
  updatedName.value = props.guest.name;
});
</script>